<?php
/*
 Newswriter v2.56
 PHP News Management System
 Copyright (C) 2000-2002 Philipp Wolfer

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the license, or
 (at your option) any later version.
 See license.txt for further information.

 newsindex.inc.php, last change: 05.08.2002

 function for displaying the newsindex
*/

function newsindex($news_count = false) {
  global $NW_RUNTIME, $NWCONF_SYSTEM, $NWCONF_INDEX, $NW_TRANSLATION;
  if (!$news_count)
    $news_count = $NWCONF_INDEX['article_newscount'];
    
  // initialize $NW_RUNTIME['showlist'] and $NW_RUNTIME['shownot']
  if (!is_array($NW_RUNTIME['showlist']) || !is_array($NW_RUNTIME['shownot']))
    set_topic_arrays();

  $dirlist = get_filelist ($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir']);
  $content = false;

  if ($dirlist) {
    $admore = true;
    for ($i = 0; $admore == true && $dirlist[$i]; $i++) {
      $adfiles = get_filelist($dirlist[$i]);
      for($j = 0; sizeof($file_data) < $news_count && $adfiles[$j]; $j++) {
        $file_entries = get_filedata($adfiles[$j]);
        if (($NW_RUNTIME['showtopic'] == $file_entries['TOPIC']
         || $NW_RUNTIME['showtopic'] == 'all'
         || !$NW_RUNTIME['showtopic']
         || in_array($file_entries['TOPIC'], $NW_RUNTIME['showlist']))
         && !in_array($file_entries['TOPIC'], $NW_RUNTIME['shownot'])) {
          if ((!$file_entries['EXPIRE'] || $file_entries['EXPIRE'] >= $NW_RUNTIME['act_timestamp']) && (!$file_entries['STARTDATE'] || $file_entries['STARTDATE'] <=  $NW_RUNTIME['act_timestamp']))
            $file_data[] = $file_entries;
        }
      }
      if (sizeof($file_data) >= $news_count)
        $admore = false;
    }
  }

  if ($file_data) {
    if (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$NW_RUNTIME['showtopic'].'/newsindex.tpl'))
      $tpl_index = file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$NW_RUNTIME['showtopic'].'/newsindex.tpl');
    else
      $tpl_index = file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].'default/newsindex.tpl');
    while(list($key, $file_entries) = each($file_data)) {
      $filename = basename($file_entries['FILENAME']);

      // check if title is too long. if so shorten it and append '...'
      if (isset($NWCONF_INDEX['max_titlelength'])) {
        if (strlen($file_entries['TITLE']) > $NWCONF_INDEX['max_titlelength'] && $NWCONF_INDEX['max_titlelength'] > 0) {
          // we first try to cut off complete words from the end, simply looks better
          while (strstr($file_entries['TITLE'], ' ') && strlen($file_entries['TITLE']) + 3 > $NWCONF_INDEX['max_titlelength']) {
            $lastblank = strrpos($file_entries['TITLE'], ' ');
            // don't shorten if title now would be shorter than the half length of 'max_titlelength'
            if ($lastblank >= $NWCONF_INDEX['max_titlelength'] / 2)
              $file_entries['TITLE'] = substr($file_entries['TITLE'], 0, $lastblank);
            else break;
          }

          // if it's still to long shorten it, even if it's in the middle of a word
          if (strlen($file_entries['TITLE']) + 3 > $NWCONF_INDEX['max_titlelength']) {
            $file_entries['TITLE'] = substr($file_entries['TITLE'], 0, $NWCONF_INDEX['max_titlelength'] - 3);
          }
          $file_entries['TITLE'] .= '...';
        }
      }

			// check if icon.gif exists for this artcile's topic or for "default"
	      if (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$file_entries['TOPIC'].'/icon'.$NWCONF_SYSTEM['icon_ext']))
          $topic_icon = '<img src="'.$NWCONF_SYSTEM['domain_path'].$NWCONF_SYSTEM['template_dir'].$file_entries['TOPIC'].'/icon'.$NWCONF_SYSTEM['icon_ext'].'" border="0" alt="'.$file_entries['TOPIC'].'">';
	      elseif (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].'default/icon'.$NWCONF_SYSTEM['icon_ext']))
          $topic_icon = '<img src="'.$NWCONF_SYSTEM['domain_path'].$NWCONF_SYSTEM['template_dir'].'default/icon'.$NWCONF_SYSTEM['icon_ext'].'" border="0" alt="'.$file_entries['TOPIC'].'">';
	      else
	        $topic_icon = false;

      if ($file_entries['ARTICLE']) {
			  if ($NWCONF_SYSTEM['readable_urls'] == true)
				{
				  // Peter Merbitz's code for the apache rewrite engine:
          $url = $NWCONF_SYSTEM['domain_path'].'article/'.$file_entries['TOPIC'].'/'.$filename.$NWCONF_SYSTEM['mod_endung'].'.html';
				}
				else
				{
          $url = $NWCONF_SYSTEM['domain_path'].'article'.$NWCONF_SYSTEM['php_ext'].'?article_file='.$file_entries['ARTICLE'];
				}
      }
      else {
        $url_date = strftime('%Y%m', $filename);
        $url = $NWCONF_SYSTEM['domain_path'].$NWCONF_SYSTEM['index_file'].'?nwaction=shownews&nwmode=archiv&showtopic='.$file_entries['TOPIC'].'&newsmonth='.$url_date.'#'.$filename;
      }
      $url = '<a href="'.$url.'" target="'.$NWCONF_INDEX['link_target'].'">'.$file_entries['TITLE'].'</a>';
      if ($NWCONF_INDEX['index_showdate'])
        $news_date = strftime($NWCONF_INDEX['index_datefmt'], $filename).' ';
      else
        $news_date = false;
      while(list($k, $line) = each($tpl_index)) {
        $line = str_replace('[--DATE--]',$news_date,$line);
        $line = str_replace('[--ICON--]', $topic_icon, $line);
        $line = str_replace('[--TITLE--]',$url,$line);
        $line = str_replace('[--TOPIC--]',$file_entries['TOPIC'],$line);
				echo $line;
      }
      reset($tpl_index);
      $content = true;
    }
  }

  if (!$content)
    echo $NW_TRANSLATION['noposts_newsindex'];
}
?>