<?php
/*
 Newswriter v2.56
 PHP News Management System
 Copyright (C) 2000-2002 Philipp Wolfer

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the license, or
 (at your option) any later version.
 See license.txt for further information.

 showfunc.inc.php, last change: 29.08.2002

 Functions used by newswriter in edit- and in show-mode:
  * show_news()                                     (line 22)
  * check_message(string filename, int msglistsize) (line 294)
  * print_news(array file_entries)                  (line 336)
*/

// Newspage / News-Archiv ausgeben:
function show_news()
{
  global $NW_RUNTIME, $NWCONF_SYSTEM, $NWCONF_DISPLAY, $NWCONF_INTERFACE, $NWCONF_USERS, $NW_TRANSLATION;

  $newmsg = true;

  $dir_list = get_filelist($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir']);

  if ($NW_RUNTIME['nwmode'] && $NW_RUNTIME['nwmode'] != 'view') {
    $month_names = array('01' => $NW_TRANSLATION['month_01'],
                         '02' => $NW_TRANSLATION['month_02'],
                         '03' => $NW_TRANSLATION['month_03'],
                         '04' => $NW_TRANSLATION['month_04'],
                         '05' => $NW_TRANSLATION['month_05'],
                         '06' => $NW_TRANSLATION['month_06'],
                         '07' => $NW_TRANSLATION['month_07'],
                         '08' => $NW_TRANSLATION['month_08'],
                         '09' => $NW_TRANSLATION['month_09'],
                         '10' => $NW_TRANSLATION['month_10'],
                         '11' => $NW_TRANSLATION['month_11'],
                         '12' => $NW_TRANSLATION['month_12']);

/* uncomment to enable listing of all months, even those which are not containing messages
    if ($dir_list) {
      $first_month = array(substr($dir_list[0], strlen($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir']) + 5), substr($dir_list[0],strlen($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir']) + 1, 4));
      $last_month = array(substr($dir_list[sizeof($dir_list) - 1], strlen($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir']) + 5), substr($dir_list[sizeof($dir_list) - 1],strlen($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir']) + 1, 4));
    }
    else {
      $first_month[0] = strftime('%m',$NW_RUNTIME['act_timestamp']);
      $first_month[1] = strftime('%Y',$NW_RUNTIME['act_timestamp']);
      $last_month[0] = $first_month[0];
      $last_month[1] = $first_month[1];
    }
    $amonth = $first_month[0];
    $ayear = $first_month[1];
*/

    // last year and month in archive:
    $amonth = substr($dir_list[0], strlen($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir']) + 5);
    $ayear  = substr($dir_list[0],strlen($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir']) + 1, 4);

    // set $NW_RUNTIME['newsmonth'] to the month to show
    if (!$NW_RUNTIME['newsmonth'] && $dir_list) {
      if (@is_dir($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir'].'/'.strftime('%Y%m',$NW_RUNTIME['act_timestamp'])))
        $NW_RUNTIME['newsmonth'] = strftime('%Y%m',$NW_RUNTIME['act_timestamp']);
      else
        $NW_RUNTIME['newsmonth'] = $ayear.$amonth;
    }

    if (!$NW_RUNTIME['newsmonth']) {
      if (is_array($dir_list))
        $file_list = get_filelist($dir_list[0]);
      $NW_RUNTIME['newsmonth'] = $ayear.$amonth;
    }
    else {
      if (is_array($dir_list)) {
        while((list($key,$month) = each($dir_list)) && $newmsg) {
          if(basename($month) == $NW_RUNTIME['newsmonth']) {
            $file_list = get_filelist($month);
            $newmsg = false;
          }
        }
        reset($dir_list);
      }
      $newmsg = true;
    }
    if ($file_list) {
      while((list($key,$file) = each($file_list)) && $newmsg) {
        $content = check_message($file, sizeof($file_content));
        if ($content) $file_content[] = $content;
      }
      reset($file_list);
    }

    echo '<br /><br /><form name="nwselection" action="'.$NWCONF_SYSTEM['domain_path'];
    if ($NW_RUNTIME['nwmode'] == 'edit')
      echo 'admin'.$NWCONF_SYSTEM['php_ext'];
    else
      echo $NWCONF_SYSTEM['index_file'];
    echo "\" method=\"post\">\n";
    echo "<input type=\"hidden\" name=\"nwaction\" value=\"shownews\">\n";
    echo '<input type="hidden" name="nwmode" value="'.$NW_RUNTIME['nwmode']."\">\n";
    if ($NW_RUNTIME['nwmode'] == 'edit') {
      echo "<input type=\"hidden\" name=\"nwpassword\" value=\"".$NW_RUNTIME['nwpassword']."\">\n";
      echo "<input type=\"hidden\" name=\"nwlogin\" value=\"".$NW_RUNTIME['nwlogin']."\">\n";
    }
    echo "<table boder=\"0\" align=\"left\"><tr><td>\n";

    // topic selection box
    echo '<b>'.$NW_TRANSLATION['archiv_topicselection'].'</b><br />';
    echo '<select name="showtopic" size="1" onChange="javascript:ReloadArchiv();">';

    while (list($index, $topic) = each($NWCONF_INTERFACE['topic_list'])) {
      if (!in_array($topic, $NW_RUNTIME['shownot']) || $NW_RUNTIME['nwmode'] == 'edit') {
        echo '<option value="'.$topic.'"';
        if ($topic == $NW_RUNTIME['showtopic'])
          echo ' selected';
        if ($topic == 'all')
          echo '>'.$NW_TRANSLATION['topic_all'].'</option>';
        else
          echo '>'.$topic.'</option>';
      }
    }
    echo "</select><br />\n";
    
    // month selection box
    echo '<b>'.$NW_TRANSLATION['archiv_displayperiod'].'</b><br />';
    echo '<select name="newsmonth" size="1" onChange="javascript:ReloadArchiv();">';

// show only months which contain messages
    while(list($key,$value) = each($dir_list)) {
      $value = basename($value);
      $ayear = substr($value, 0, 4);
      $amonth = substr($value, 4);
      echo "<option value=\"$value\"";
      if($ayear.$amonth == $NW_RUNTIME['newsmonth'])
        echo ' selected';
      echo ">$month_names[$amonth] $ayear</option>\n";
    }

/* uncomment to enable listing of all months, even those which are not containing messages
    while($ayear >= $last_month[1]) {
      echo "<option value=\"$ayear$amonth\"";
      if($ayear.$amonth == $NW_RUNTIME['newsmonth'])
        echo ' selected';
      echo ">$month_names[$amonth] $ayear</option>\n";
      if ($amonth == $last_month[0] && $ayear == $last_month[1])
        $ayear = $last_month[1] - 1;
      $amonth--;
      if ($amonth == 0) {
        $amonth = 12;
        $ayear--;
      }
      if ($amonth < 10)
        $amonth = '0'.$amonth;
    }
*/

    echo "</select>\n";

    echo '&nbsp;&nbsp;<input type="image" src="'.$NWCONF_SYSTEM['domain_path'].$NWCONF_SYSTEM['picture_dir'].'akt.gif" border="0">';
    echo "</td></tr></table>\n";
    echo "</form>\n";
?>
<script language="JavaScript">
<!--
function ReloadArchiv()
{
  location.href = '<?php echo $NWCONF_SYSTEM['domain_path'];
    if ($NW_RUNTIME['nwmode'] == 'edit')
      echo 'admin'.$NWCONF_SYSTEM['php_ext'].'?nwpassword='.$NW_RUNTIME['nwpassword'].'&nwlogin='.$NW_RUNTIME['nwlogin'].'&';
    else
      echo $NWCONF_SYSTEM['index_file'].'?';
   ?>nwaction=shownews&nwmode=<?php echo $NW_RUNTIME['nwmode']; ?>&showtopic='
   + document.nwselection.showtopic.options[document.nwselection.showtopic.selectedIndex].value
   + '&newsmonth=' + document.nwselection.newsmonth.options[document.nwselection.newsmonth.selectedIndex].value;
   //alert('TEST: ' + document.forms["nwselection"].newsmonth.options[0].value);
}
//-->
</script>
<?php
    if ($NW_RUNTIME['nwmode'] == 'edit') {
      echo "<form action=\"".$NWCONF_SYSTEM['domain_path']."admin".$NWCONF_SYSTEM['php_ext']."\" method=\"post\">\n";
      echo "<input type=\"hidden\" name=\"nwmode\" value=\"edit\">\n";
      echo "<input type=\"hidden\" name=\"nwaction\" value=\"edit\">\n";
      echo "<input type=\"hidden\" name=\"nwpassword\" value=\"".$NW_RUNTIME['nwpassword']."\">\n";
      echo "<input type=\"hidden\" name=\"nwlogin\" value=\"".$NW_RUNTIME['nwlogin']."\">\n";
      echo '<br /><center><input type="submit" size="35" maxlength="60" value="'.$NW_TRANSLATION['edit_editchosennews'].'"></center>';
    }
    echo '<br clear="all">';
  }
  else {
    $count_months = ceil($NWCONF_DISPLAY['max_days'] / 30) - 1;
    if ($count_months < 0)
      $count_months = 0;
    for($i = 0; $i <= $count_months; $i++) {
      if (is_array($dir_list))
        $adfiles = get_filelist($dir_list[$i]);
      if (is_array($adfiles)) {
        while (list($key, $file) = each($adfiles)) {
          $content = check_message($file, sizeof($file_content));
          if ($content) $file_content[] = $content;
        }
      }
      if ($i == $count_months && sizeof($file_content) < $NWCONF_DISPLAY['min_shownews'] && is_array($dir_list)) {
        for($count = $i + 1; sizeof($file_content) < $NWCONF_DISPLAY['min_shownews'] && $dir_list[$count]; $count++) {
          $adfiles = get_filelist($dir_list[$count]);
          if (is_array($adfiles))
          {
            while(list($key,$file) = each($adfiles)) {
              $content = check_message($file, sizeof($file_content));
              if ($content) $file_content[] = $content;
            }
          }
        }
      }
    }
  }

  echo "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"4\"><tr>\n";
  if ($dir_list && $file_content) {
    if ($NWCONF_DISPLAY['highlight_first'] && $NW_RUNTIME['nwmode'] != 'edit' && $NW_RUNTIME['nwmode'] != 'archiv') {
			echo '<td width="100%" colspan="'.$NWCONF_DISPLAY['max_cols'].'">';
			print_news($file_content[0], 'firstmsg.tpl');
			echo "</td></tr></table>";
			if (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$NW_RUNTIME['showtopic'].'/firstmsg.tpl.php'))
			  $filename = $NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$NW_RUNTIME['showtopic'].'/firstmsg.tpl.php';
			elseif (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].'/default/firstmsg.tpl.php'))
			  $filename = $NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].'/default/firstmsg.tpl.php';
			if (!$NW_INCLUDED[$filename]) {
			  $NW_INCLUDED[$filename] = true;
			  include($filename);
			}
			echo "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"4\"><tr>\n";
		}
    for($col = 0; $col < $NWCONF_DISPLAY['max_cols']; $col++) {

      if (!strstr($NWCONF_DISPLAY['table_width'],'%'))
        $tw = $NWCONF_DISPLAY['table_width'];
      else
        $tw = 100;
      if($col < $NWCONF_DISPLAY['max_cols'] - 1)
        $col_width = floor($tw / $NWCONF_DISPLAY['max_cols']);
      else
        $col_width = ceil($tw / $NWCONF_DISPLAY['max_cols']);
      if (strstr($NWCONF_DISPLAY['table_width'],'%'))
        $col_width .= '%';

      $i = $col;
      if ($NWCONF_DISPLAY['highlight_first'] && $NW_RUNTIME['nwmode'] != 'edit' && $NW_RUNTIME['nwmode'] != 'archiv')
        $i++;

			echo "<td width=\"$col_width\" valign=\"top\">\n";
      if(!$file_content[$col]) {
        echo '&nbsp;';
      }
      else {
        for($i; $file_content[$i]; $i = $i + $NWCONF_DISPLAY['max_cols']) {
          if($NW_RUNTIME['nwmode'] == 'edit') {
            echo '<input type="radio" name="file_name" value="'.$file_content[$i]['FILENAME'].'"';
            if($i == 0)
              echo " checked";
            echo ">";
          }
          print_news($file_content[$i]);
          if(isset($file_content[$i + $NWCONF_DISPLAY['max_cols']]))
            echo $NWCONF_DISPLAY['news_divider'];
        }
      }
      echo "</td>\n";
    }
    echo "</tr></table>\n";
    if (!$file_content && $NW_RUNTIME['nwmode'] && $NW_RUNTIME['nwmode'] != 'view')
      echo '<p>'.$NW_TRANSLATION['noposts_month_1'].$month_names[substr($NW_RUNTIME['newsmonth'],4)].' '.substr($NW_RUNTIME['newsmonth'],0,4).$NW_TRANSLATION['noposts_month_1'].'</p>';
    elseif (!$file_content && (!$NW_RUNTIME['nwmode'] || $NW_RUNTIME['nwmode'] == 'view'))
      echo '<p>'.$NW_TRANSLATION['noposts_lastdays_1'].$NWCONF_DISPLAY['max_days'].$NW_TRANSLATION['noposts_lastdays_2'].'</p>';
    if ($NW_RUNTIME['nwmode'] == 'edit')
      echo '</form>';
  }
  elseif (!$file_content && $NW_RUNTIME['nwmode'] && $NW_RUNTIME['nwmode'] != 'view') {
    echo '<td>&nbsp;</td></tr></table><p>'.$NW_TRANSLATION['noposts_month_1'].$month_names[substr($NW_RUNTIME['newsmonth'],4)].' '.substr($NW_RUNTIME['newsmonth'],0,4).$NW_TRANSLATION['noposts_month_2'].'</p>';
  }
  else {
    echo '<td>&nbsp;</td></tr></table><p>'.$NW_TRANSLATION['noposts_lastdays_1'].$NWCONF_DISPLAY['max_days'].$NW_TRANSLATION['noposts_lastdays_2'].'</p>';
  }
}

// check given message if it should be displayed or not
function check_message($file, $msglistsize) {
  global $NW_RUNTIME, $NWCONF_DISPLAY, $NWCONF_USERS, $NWCONF_INTERFACE;

  $file_entries = get_filedata($file);

  // check when in archiv
  if ($NW_RUNTIME['nwmode'] == 'archiv') {
    if ((!$NW_RUNTIME['showtopic']
     || $NW_RUNTIME['showtopic'] == $file_entries['TOPIC']
     || $NW_RUNTIME['showtopic'] == 'all'
     || in_array($file_entries['TOPIC'], $NW_RUNTIME['showlist']))
     && !in_array($file_entries['TOPIC'], $NW_RUNTIME['shownot'])
     && (!$file_entries['STARTDATE'] || $file_entries['STARTDATE'] <=  $NW_RUNTIME['act_timestamp'])) {
       return $file_entries;
    }
  }
  // check in edit mode
  elseif ($NW_RUNTIME['nwmode'] == 'edit') {
    if ((!$NW_RUNTIME['showtopic']
     || $NW_RUNTIME['showtopic'] == $file_entries['TOPIC']
     || $NW_RUNTIME['showtopic'] == 'all')
		 && ($NW_RUNTIME['admin_mode']
     || ($file_entries['NAME'] == $NWCONF_USERS['realname'][$NW_RUNTIME['nwlogin']] && $NWCONF_INTERFACE['allow_edit'] == true))) {
      return $file_entries;
    }
  }
  // check on newspage
  else {
    if(($NW_RUNTIME['act_timestamp'] - basename($file) <= $NWCONF_DISPLAY['max_days'] * 86400 && $msglistsize < $NWCONF_DISPLAY['max_shownews']) || $msglistsize < $NWCONF_DISPLAY['min_shownews']) {
      if ((!$NW_RUNTIME['showtopic']
        || $NW_RUNTIME['showtopic'] == $file_entries['TOPIC']
        || $NW_RUNTIME['showtopic'] == 'all'
        || in_array($file_entries['TOPIC'], $NW_RUNTIME['showlist']))
	&& !in_array($file_entries['TOPIC'], $NW_RUNTIME['shownot'])
        && (!$file_entries['EXPIRE'] || $file_entries['EXPIRE'] >= $NW_RUNTIME['act_timestamp'])
	&& (!$file_entries['STARTDATE'] || $file_entries['STARTDATE'] <= $NW_RUNTIME['act_timestamp'])) {
          return $file_entries;
      }
    }
  }

  return false;
}

// Nachricht entsprechend Vorlage $template ausgeben:
function print_news($file_entries, $template = 'news.tpl')
{
  global $NW_RUNTIME, $NWCONF_SYSTEM, $NWCONF_DISPLAY, $NWCONF_INTERFACE, $NW_TRANSLATION;

  // select correct template
	if ($NW_RUNTIME['nwmode'] == 'edit') {
    $news_template = file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].'admin/news.tpl');
  }
  else {
    if (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$NW_RUNTIME['showtopic'].'/'.$template))
      $news_template = file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$NW_RUNTIME['showtopic'].'/'.$template);
    elseif (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$NW_RUNTIME['showtopic'].'/news.tpl'))
      $news_template = file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$NW_RUNTIME['showtopic'].'/news.tpl');
    elseif (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].'default/'.$template))
      $news_template = file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].'default/'.$template);
    else
      $news_template = file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].'default/news.tpl');
  }

	// check if icon.gif exists for this artcile's topic or for "default"
	if (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].$file_entries['TOPIC'].'/icon'.$NWCONF_SYSTEM['icon_ext']))
    $topic_icon = '<img src="'.$NWCONF_SYSTEM['domain_path'].$NWCONF_SYSTEM['template_dir'].$file_entries['TOPIC'].'/icon'.$NWCONF_SYSTEM['icon_ext'].'" border="0" alt="'.$file_entries['TOPIC'].'">';
	elseif (@is_file($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['template_dir'].'default/icon'.$NWCONF_SYSTEM['icon_ext']))
    $topic_icon = '<img src="'.$NWCONF_SYSTEM['domain_path'].$NWCONF_SYSTEM['template_dir'].'default/icon'.$NWCONF_SYSTEM['icon_ext'].'" border="0" alt="'.$file_entries['TOPIC'].'">';
	else
	  $topic_icon = false;


	$news = $news_template;
  $filename = basename($file_entries['FILENAME']);

  // URL zum weiterfuehrenden Artikel festlegen
	if (isset($file_entries['ARTICLE']))
	{
    if ($NWCONF_SYSTEM['readable_urls'] == true)
		{
		  // Peter Merbitz's code for the apache rewrite engine:
			$articleurl = $NWCONF_SYSTEM['domain_path'].'article/'.$file_entries['TOPIC'].'/'.$filename.'.html';
		}
		else
		{
      $articleurl = $NWCONF_SYSTEM['domain_path'].'article'.$NWCONF_SYSTEM['php_ext'].'?article_file='.$file_entries['ARTICLE'];
      if (isset($NW_RUNTIME['showtopic']) && $NW_RUNTIME['showtopic'] != 'all')
          $articleurl .= '&showtopic='.$NW_RUNTIME['showtopic'];
		}
	}

	while (list($key,$line) = each($news)) {
    if ($file_entries['TOPIC'] == 'all')
      $line = str_replace('[--TOPIC--]',$NW_TRANSLATION['topic_all'],$line);
    else
      $line = str_replace('[--TOPIC--]',$file_entries['TOPIC'],$line);
    $line = str_replace('[--SUBTOPIC--]',$file_entries['SUBTOPIC'],$line);
    $line = str_replace('[--TITLE--]','<a name="'.$filename.'">'.$file_entries['TITLE'].'</a>',$line);
    if (isset($file_entries['ARTICLE']))
		{
		  $line = str_replace('[--TITLE_LINKED--]','<a name="'.$filename.'"><a href="'.$articleurl.'" class="newstitle">'.$file_entries['TITLE'].'</a></a>',$line);
		}
    else
		{
      $line = str_replace('[--TITLE_LINKED--]','<a name="'.$filename.'">'.$file_entries['TITLE'].'</a>',$line);
		}
    $line = str_replace('[--DATE--]',$file_entries['DATE'],$line);
    $line = str_replace('[--TIME--]',strftime('%H:%M',$filename),$line);
    if (isset($file_entries['CHANGEDDATE'])) {
      $markchanged = str_replace('[--DATE--]',$file_entries['CHANGEDDATE'],$NW_TRANSLATION['news_markchanged']);
      $markchanged = str_replace('[--AUTHOR--]',$file_entries['CHANGEDBY'],$markchanged);
      $line = str_replace('[--CHANGED--]',$markchanged,$line);
    }
    else {
      $line = str_replace('[--CHANGED--]','',$line);
    }
    if (isset($file_entries['LINK']) && !isset($file_entries['ARTICLE'])) {
      $line = str_replace('[--LINK--]',$NW_TRANSLATION['layout_linkleft'].$file_entries['LINK'].$NW_TRANSLATION['layout_linkright'],$line);
    }
    elseif (isset($file_entries['ARTICLE'])) {
      $link = '<nobr>'.$NW_TRANSLATION['layout_readonleft'].'<a href="';
      $link .= $articleurl;
			$link .= '">'.$NW_TRANSLATION['show_more'].'</a>'.$NW_TRANSLATION['layout_readonright'].'</nobr>';
      $line = str_replace('[--LINK--]', $link, $line);
    }
    else {
      $line = str_replace('[--LINK--]','',$line);
    }
    if (isset($file_entries['URL']))
      $line = str_replace('[--AUTHOR--]','<a href="'.$file_entries['URL'].'">'.$file_entries['NAME'].'</a>',$line);
    elseif (isset($file_entries['EMAIL']))
      $line = str_replace('[--AUTHOR--]','<a href="mailto:'.$file_entries['EMAIL'].'">'.$file_entries['NAME'].'</a>',$line);
    else
      $line = str_replace('[--AUTHOR--]',$file_entries['NAME'],$line);
    if (isset($file_entries['IMAGE1'])) {
      list($img1_url, $img1_align) = explode ('***',$file_entries['IMAGE1']);
      $img_tag = '<img src="'.$img1_url.'" border="0" alt="'.$file_entries['TITLE'].'" vspace="'.$NWCONF_DISPLAY['image_space'].'" hspace="'.$NWCONF_DISPLAY['image_space'].'"';
      if ($img1_align == 'ontop')
        $img_tag .= '><br clear="all">';
      else
        $img_tag .= ' align="'.$img1_align.'">';
      if (isset($file_entries['ARTICLE']))
        $img_tag = '<a href="'.$articleurl.'">'.$img_tag.'</a>';
      $line = str_replace('[--IMAGE--]',$img_tag,$line);
    }
    else {
      $line = str_replace('[--IMAGE--]','',$line);
    }
    $line = str_replace('[--ICON--]', $topic_icon, $line);
		$line = str_replace('[--TEXT--]',$file_entries['TEXT'],$line);

		echo $line;
  }
}
?>