<?php
/*
 Newswriter v2.56
 PHP News Management System
 Copyright (C) 2000-2002 Philipp Wolfer

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the license, or
 (at your option) any later version.
 See license.txt for further information.

 userfunc.inc.php, change 10.01.2002

 Functions for receiving user information:
  * check_for_admin(string username) (line 21)
  * get_login_name(string username)  (line 37)
*/

// Check if specified user is admin:
function check_for_admin($username) {
  global $NWCONF_USERS;
  $result = false;
  if (is_array($NWCONF_USERS['admins'])) {
    while (list($key,$adminid) = each($NWCONF_USERS['admins'])) {
      if ($username == $adminid) {
        $result = true;
        break;
      }
    }
    reset($NWCONF_USERS['admins']);
  }
  return $result;
}

// Get the login name for user's realname:
function get_loginname($username) {
  global $NWCONF_USERS;
  if (is_array($NWCONF_USERS['realname'])) {
    while (list($login,$name) = each($NWCONF_USERS['realname'])) {
      if ($name == $username) {
        $result = $login;
        break;
      }
    }
    reset($NWCONF_USERS['realname']);
  }
  return $result;
}
